

TACHYON
\ [~

{  
			UPDATED 20121203.1900 BBR
			UPDATED 20121201.1800 BB Riley, Underhill Center, VT
			CREATED	20121001.0000 Nicholas Lordi, Manasquan, NJ
			
                 TACHYON V2.1   um-FPU64 Access     

   See uM-FPU64 Datasheet and Instruction Set for details.  }

: uMfpu64.fth  ." Floating Point Math Chip Toolkit - 20121203.1900 " ;


{
	SPI Words  - require generic SPI wordset in SF2MEM.txt.

	Pin Assignments - scs is not needed, since the FPU cs pin is wired to ground

	2-WIRE SPI - 20121201 - as of this date Tacyon doesn't support 2-wire form

#21  MASK CONSTANT .miso
#20  MASK CONSTANT .sclk
#21  MASK CONSTANT .mosi

}


 '' 3-WIRE SPI
#19		MASK	CONSTANT .miso
#20		MASK	CONSTANT .sclk
#21		MASK	CONSTANT .mosi

#4				CONSTANT #fpubusy   \ monitor FPU busy signal (lo - busy   hi - not busy)


:	FPUBUSY?	( -- )	#fpubusy PIN@ IF FALSE ELSE TRUE THEN ;


: !SPI  ( -- ) \  Initialize spi engine (2.8 MHz).
    #8		3 COGREG!
    .miso	2 COGREG!
    .mosi	1 COGREG!
    .sclk	0 COGREG!
    .mosi 	OUTCLR
    .sclk	OUTCLR   ;


\  --- basic primitives to transfer Prop <---> FPU64 ---

: FPU>   ( -- b ) \ Leaves 1 byte on stack.
    SP@ ;

: >FPU   ( b -- ) \ Sends 1 byte to  FPU64.
    SP! ;

: W>FPU  ( w -- ) \ Sends 1 word to FPU64.
    DUP #8 SHR SP! SP!  ;

: FPU>W  ( -- w ) \ Leaves 1 word on stack.
   SP2@  ;

: L>FPU  ( l -- ) \ Sends 1 long to FPU64.
    DUP #24 SHR SP! DUP #16 SHR SP! DUP #8 SHR SP! SP! ;

: FPU>L  ( -- l ) \  Leaves 1 long on stack.
   SP@  #8 SHL SP@ OR  #8 SHL SP@ OR #8 SHL SP@ OR ;






'' Utilities

WVARIABLE REGA   \ stores reg A  number
WVARIABLE REGX   \ stores reg X  number

: !FPU  ( -- b )  \ Initialize SPI engine and resets the fpu chip. Leaves $5C on stack if fpu is in sync																						
		!SPI CR	 ." FPU Sync - "					\  start SPI Engine
		10 0 DO #reset SP! LOOP  	\  FPU software reset
		#noop SP! 10 ms #sync SP! 
		SP@ DUP #synchar  = IF  ." Successfull"	DROP			ELSE
								." Failed! Received: $" .BYTE	THEN
		CR
		;
		
: FDEBUG  ( -- )	\ Actvate fpu debug mode on a serial terminal (56700 baud) attached to 
					\  the fpu serial out pin.
    #fserout SP! 0 SP! 0 SP! ;




'' Some Useful Subroutines

: SETREGA  ( n1 -- )  \ Assigns register A as register #n1.
    DUP REGA W! #selecta SP! SP!  ;

: SETREGX  ( n1 -- )  \ Assigns register X as register #n1.
    DUP REGX W! #selectx SP! SP!  ;

\  All these functions start/end with value in FPU A-REG
\  Use  I>FP, FP>I, FP>L, etc to access results   

: SQRT	( -- )	 #sqrt SP!  ;

: SIN	( -- )	 #sin SP! ;

: COS	( -- )	 #cos SP! ;

: TAN	( -- )	 #tan SP! ;

: LOG10	( -- )	 #log SP! ;

: LOADPI	( -- )	#loadpi SP!  ;

: FMUL0	( -- )	 #fmul0  SP!  ;


: I>FP ( l -- ) 	\  Stores long to fpu reg A and converts it to floating point.
    #lwritea SP! L>FPU  #float SP!
	;

: FP>I ( -- l )		\  Places integer form of floating point value in fpu reg A
 					\  on stack. Value unchanged in reg A.
    #copya SP! #0 SP! #fixr SP! #lreada SP! 1 ms FPU>L #copy0 SP! REGA W@ SP!
	;

: SCALEUP  ( n1 -- )  \ Multiplies fp value in reg A by n1.
    #copya SP! #0 SP! I>FP #selectx SP! SP! #clr0 SP!
	;

: SCALEDN  ( n1 -- )   \ Divides fp value in reg A by n1.
    #copya SP! #0 SP! I>FP #fdivr0 SP! #clr0 SP!
	;


\  ---- FPU string buffer subroutines -----------------------------

: .stringbuffer	( -- )		\  #readstring will start sending the contents of the FPU's
							\  string buffer to Prop terminated by a null
		#readstring	SP!
		BEGIN
			FPU> ?DUP IF	EMIT  FALSE	ELSE
							TRUE		THEN
		UNTIL
		;

:  .version	( -- )	#version SP! .stringbuffer ; 

:	sendFPUstring	( string -- )	\  send null terminated string to FPU
									\  send the string
		BEGIN C@++ ?DUP WHILE SP! REPEAT DROP 
		0 SP!						\ send terminating null
		;

:	STR>FP	( string strlen -- )	\  send string from prop, convert to float,
		#strsel SP! 0 SP! SP!		\  set string selection point
		#strins SP!					\  tell FPU string is coming
		sendFPUstring				\  send the string
		#strtof SP!					\  convert to float in Reg-0
		;

:	STR>SBuf ( string -- )	\  send string from prop to FPU String BUFFER
		#strset SP!					\  tell FPU string is coming
		sendFPUstring				\  send the string
		;




\  ---- FPU's Serial LCD subroutines ------------------------------

: !LCD  ( -- ) 		\  Initializes serial lcd attached to the fpu's serial port at 19200 baud.
    	#fserout SP! $00 SP!  #7 SP!  
		;

: >LCD ( b -- )  	\  Sends byte to lcd.
		#fserout SP! $01 SP! SP! $0 SP! 
		;

: >LCDSTR	( string -- )	\ send string from Prop to FPU serial LCD port
		BEGIN C@++ ?DUP WHILE >LCD REPEAT DROP 
		;

: FP>LCD  ( n1 -- )  \  Converts value in FPU reg A to a string of length n1 (max 10) to 
					 \  the fpu's lcd.
    	#ftoa SP! #0 SP! #strsel SP! #0 SP! SP! 
		#fserout SP! #3 SP! #13 >LCD 
		;

: >PHALCD	( cmd -- ) "?" >LCD >LCD ;
: LCLS		( -- ) "f" >PHALCD ;
: LHOME		( -- ) "a" >PHALCD ;
: LCR		( -- ) "n" >PHALCD ;
: LSPACE	( -- ) " " >LCD ;

\  --------- Brian's Shortcuts-----------------------

: BBR.fth  ." Brian's Shortcuts - 20121203.2100 " ;



:	STARTUP	( -- )
	!FPU			\  startup FPU64
	5 SETREGA		\  SETUP REGS A & X (0-127 32 bit)
	6 SETREGX		\  					(128-255 64 but)
	!LCD			\  startup FPU serial LCD
	LCLS
	SD				\  startup SD card socket
	#220 $E0 @LCD	\  startup Prop serial LCD
	;

: LSTART	( -- )
	LCD
	"  ?f Knit 1, Pearl 2?nProp Forth yoo hoo!" .STR
	CON
	;

: startup	STARTUP ;
: .s .S ;
: backup BACKUP ;
: restore RESTORE ;
: eecopy EECOPY ;
: reboot REBOOT ;
: tasks TASKS ;
: modules MODULES ;	
: lstart LSTART ;


]~
END


\  ---------- BRIAN'S SCRIBBLES ------------------


:	STRLEN	( string -- len )

		DUP 0 OVER			\  save string pointer, initialize ccounter
		BEGIN C@++ ?DUP WHILE >LCD REPEAT DROP 
		
LHOME


  " 1112.8648" STR>SBuf #strtof SP! #copy0 SP! 5 SP! SQRT #8 FP>LCD






#1234567 .S I>FP SQRT #8 FP>LCD FP>I .S .

LOADPI #10 SCALEDN  SIN 8 FP>LCD


: kl
BEGIN
	C@++ ?DUP IF	EMIT  TRUE THEN
WHILE
;


: kk	( string -- len )

	DUP 0 OVER
	BEGIN
		.S C@++ ?DUP IF SWAP 1+ SWAP  FALSE	ELSE
						TRUE		THEN
	UNTIL
	;


